/******************************************************************************
 * Product: Compiere ERP & CRM Smart Business Solution                        *
 * Copyright (C) 1999-2007 ComPiere, Inc. All Rights Reserved.                *
 * This program is free software, you can redistribute it and/or modify it    *
 * under the terms version 2 of the GNU General Public License as published   *
 * by the Free Software Foundation. This program is distributed in the hope   *
 * that it will be useful, but WITHOUT ANY WARRANTY, without even the implied *
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.           *
 * See the GNU General Public License for more details.                       *
 * You should have received a copy of the GNU General Public License along    *
 * with this program, if not, write to the Free Software Foundation, Inc.,    *
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.                     *
 * For the text or an alternative of this public license, you may reach us    *
 * ComPiere, Inc., 3600 Bridge Parkway #102, Redwood City, CA 94065, USA      *
 * or via info@compiere.org or http://www.compiere.org/license.html           *
 *****************************************************************************/
package org.compiere.model;

/** Generated Model - DO NOT CHANGE */
import java.sql.*;
import java.math.*;
import org.compiere.framework.*;
import org.compiere.util.*;
/** Generated Model for C_PeriodControl
 *  @author Jorg Janke (generated) 
 *  @version Release 3.0.0 - $Id: GenerateModel.java,v 1.1 2008/01/16 07:34:32 jrmt Exp $ */
public class X_C_PeriodControl extends PO
{
/** Standard Constructor
@param ctx context
@param C_PeriodControl_ID id
@param trxName transaction
*/
public X_C_PeriodControl (Ctx ctx, int C_PeriodControl_ID, String trxName)
{
super (ctx, C_PeriodControl_ID, trxName);
/** if (C_PeriodControl_ID == 0)
{
setC_PeriodControl_ID (0);
setC_Period_ID (0);
setDocBaseType (null);
setPeriodAction (null);	// N
}
 */
}
/** Load Constructor 
@param ctx context
@param rs result set 
@param trxName transaction
*/
public X_C_PeriodControl (Ctx ctx, ResultSet rs, String trxName)
{
super (ctx, rs, trxName);
}
/** Serial Version No */
static final long serialVersionUID = 27472783772789L;
/** Last Updated Timestamp 2007-09-25 03:27:36.0 */
public static final long updatedMS = 1190658456000L;
/** AD_Table_ID=229 */
public static final int Table_ID=229;

/** TableName=C_PeriodControl */
public static final String Table_Name="C_PeriodControl";

protected static KeyNamePair Model = new KeyNamePair(229,"C_PeriodControl");

protected BigDecimal accessLevel = new BigDecimal(2);
/** AccessLevel
@return 2 - Client 
*/
protected int get_AccessLevel()
{
return accessLevel.intValue();
}
/** Load Meta Data
@param ctx context
@return PO Info
*/
protected POInfo initPO (Ctx ctx)
{
POInfo poi = POInfo.getPOInfo (ctx, Table_ID);
return poi;
}
/** Info
@return info
*/
public String toString()
{
StringBuffer sb = new StringBuffer ("X_C_PeriodControl[").append(get_ID()).append("]");
return sb.toString();
}
/** Set Period Control.
@param C_PeriodControl_ID Period Control */
public void setC_PeriodControl_ID (int C_PeriodControl_ID)
{
if (C_PeriodControl_ID < 1) throw new IllegalArgumentException ("C_PeriodControl_ID is mandatory.");
set_ValueNoCheck ("C_PeriodControl_ID", new Integer(C_PeriodControl_ID));
}
/** Get Period Control.
@return Period Control */
public int getC_PeriodControl_ID() 
{
Integer ii = (Integer)get_Value("C_PeriodControl_ID");
if (ii == null) return 0;
return ii.intValue();
}
/** Get Record ID/ColumnName
@return ID/ColumnName pair */
public KeyNamePair getKeyNamePair() 
{
return new KeyNamePair(get_ID(), String.valueOf(getC_PeriodControl_ID()));
}
/** Set Period.
@param C_Period_ID Period of the Calendar */
public void setC_Period_ID (int C_Period_ID)
{
if (C_Period_ID < 1) throw new IllegalArgumentException ("C_Period_ID is mandatory.");
set_ValueNoCheck ("C_Period_ID", new Integer(C_Period_ID));
}
/** Get Period.
@return Period of the Calendar */
public int getC_Period_ID() 
{
Integer ii = (Integer)get_Value("C_Period_ID");
if (ii == null) return 0;
return ii.intValue();
}

/** DocBaseType AD_Reference_ID=432 */
public static final int DOCBASETYPE_AD_Reference_ID=432;
/** Set Document BaseType.
@param DocBaseType Logical type of document */
public void setDocBaseType (String DocBaseType)
{
if (DocBaseType.length() > 3)
{
log.warning("Length > 3 - truncated");
DocBaseType = DocBaseType.substring(0,3);
}
set_ValueNoCheck ("DocBaseType", DocBaseType);
}
/** Get Document BaseType.
@return Logical type of document */
public String getDocBaseType() 
{
return (String)get_Value("DocBaseType");
}

/** PeriodAction AD_Reference_ID=176 */
public static final int PERIODACTION_AD_Reference_ID=176;
/** Close Period = C */
public static final String PERIODACTION_ClosePeriod = "C";
/** <No Action> = N */
public static final String PERIODACTION_NoAction = "N";
/** Open Period = O */
public static final String PERIODACTION_OpenPeriod = "O";
/** Permanently Close Period = P */
public static final String PERIODACTION_PermanentlyClosePeriod = "P";
/** Is test a valid value.
@param test testvalue
@returns true if valid **/
public boolean isPeriodActionValid (String test)
{
return test.equals("C") || test.equals("N") || test.equals("O") || test.equals("P");
}
/** Set Period Action.
@param PeriodAction Action taken for this period */
public void setPeriodAction (String PeriodAction)
{
if (PeriodAction == null) throw new IllegalArgumentException ("PeriodAction is mandatory");
if (!isPeriodActionValid(PeriodAction))
throw new IllegalArgumentException ("PeriodAction Invalid value - " + PeriodAction + " - Reference_ID=176 - C - N - O - P");
if (PeriodAction.length() > 1)
{
log.warning("Length > 1 - truncated");
PeriodAction = PeriodAction.substring(0,1);
}
set_Value ("PeriodAction", PeriodAction);
}
/** Get Period Action.
@return Action taken for this period */
public String getPeriodAction() 
{
return (String)get_Value("PeriodAction");
}

/** PeriodStatus AD_Reference_ID=177 */
public static final int PERIODSTATUS_AD_Reference_ID=177;
/** Closed = C */
public static final String PERIODSTATUS_Closed = "C";
/** Never opened = N */
public static final String PERIODSTATUS_NeverOpened = "N";
/** Open = O */
public static final String PERIODSTATUS_Open = "O";
/** Permanently closed = P */
public static final String PERIODSTATUS_PermanentlyClosed = "P";
/** Is test a valid value.
@param test testvalue
@returns true if valid **/
public boolean isPeriodStatusValid (String test)
{
return test == null || test.equals("C") || test.equals("N") || test.equals("O") || test.equals("P");
}
/** Set Period Status.
@param PeriodStatus Current state of this period */
public void setPeriodStatus (String PeriodStatus)
{
if (!isPeriodStatusValid(PeriodStatus))
throw new IllegalArgumentException ("PeriodStatus Invalid value - " + PeriodStatus + " - Reference_ID=177 - C - N - O - P");
if (PeriodStatus != null && PeriodStatus.length() > 1)
{
log.warning("Length > 1 - truncated");
PeriodStatus = PeriodStatus.substring(0,1);
}
set_ValueNoCheck ("PeriodStatus", PeriodStatus);
}
/** Get Period Status.
@return Current state of this period */
public String getPeriodStatus() 
{
return (String)get_Value("PeriodStatus");
}
/** Set Process Now.
@param Processing Process Now */
public void setProcessing (boolean Processing)
{
set_Value ("Processing", new Boolean(Processing));
}
/** Get Process Now.
@return Process Now */
public boolean isProcessing() 
{
Object oo = get_Value("Processing");
if (oo != null) 
{
 if (oo instanceof Boolean) return ((Boolean)oo).booleanValue();
 return "Y".equals(oo);
}
return false;
}
}
